variables:
  GITLAB_CI_DEBIAN_IMAGE: "debian:bookworm"
  GITLAB_CI_LLVM_APT_REPOSITORY: "deb http://apt.llvm.org/bookworm/ llvm-toolchain-bookworm-17 main"
  GIT_SUBMODULE_STRATEGY: recursive
  GIT_DEPTH: 1

stages:
  - static
  - build

include:
  - project: "librespacefoundation/templates/gitlab-ci"
    ref: "main"
    file: ".gitlab-ci-sign-off.yml"

sign_off:
  stage: static
  needs: []

# 'static' stage
static:
  image: ${GITLAB_CI_DEBIAN_IMAGE}
  stage: static
  needs: []
  before_script:
    - apt-get -q update
    - apt-get -qy install gnupg libcurl4 wget
    - echo "$GITLAB_CI_LLVM_APT_REPOSITORY" > /etc/apt/sources.list.d/llvm.list
    - wget -O - https://apt.llvm.org/llvm-snapshot.gpg.key | apt-key add -
    - apt-get -q update
    - apt-get -qy install clang-format-17 python3-pip
    - pip install --break-system-packages -U cmake_format

  script:
    - clang-format-17 --dry-run --style file --verbose --Werror -i src/*.cpp src/*.hpp
    - cmake-format --check --enable-sort=true --autosort=true CMakeLists.txt

  # 'build' stage
build:
  stage: build
  needs: []
  image: ${GITLAB_CI_DEBIAN_IMAGE}
  before_script:
    - apt-get -q update
    - |
      apt-get install -qy --no-install-recommends git ca-certificates cmake \
       cmake-extras make gcc gcc-multilib g++-multilib  libcpprest-dev \
       libboost-system-dev libboost-random-dev libspdlog-dev libeigen3-dev \
       nlohmann-json3-dev

    - update-ca-certificates
    # Debian package of libyaml-cpp 0.7.0 has a bug at CMake...
    - git clone --branch=0.8.0 --depth=1 https://github.com/jbeder/yaml-cpp
    - cd yaml-cpp
    - mkdir build
    - cd build
    - cmake -DYAML_BUILD_SHARED_LIBS=on ..
    - make
    - make install
    - ldconfig
    - cd ../../

  script:
    - mkdir build
    - cd build
    - cmake ..
    - make
